\name{cec05api}
\alias{initializeBenchmark}
\alias{destroyBenchmark}
\alias{computeBenchmark}
\title{Running calculations}
\description{
	This page shows how to set up the benchmark and run calculations.
}
\usage{
initializeBenchmark(fno, dim, seed = 0)
destroyBenchmark()
computeBenchmark(x)
}
\arguments{
	\item{fno}{function number; from 1 to 25}
	\item{dim}{number of dimensions; possible values are 2, 10, 30, 50}
	\item{seed}{affects only functions 4 and 17}
	\item{x}{point to be evaluated}
}
\details{
  In order to use any function the benchmark has to be initialized.
  To switch to another function one has to call \code{destroyBenchmark}
  prior to calling \code{initializeBenchmark} again.

  For more details see \url{http://www.bionik.tu-berlin.de/user/niko/cec2005.html}.
}
\seealso{
	\code{\link{cec05testbed}}
}
\author{
  Lukasz Bartnik
}
\examples{
# shifted sphere function
initializeBenchmark(1,2)
computeBenchmark(runif(2))
destroyBenchmark()

# Rosenbrock
initializeBenchmark(6,10)
computeBenchmark(runif(10))
destroyBenchmark()
}

